/*
 * Zaz
 * Copyright (C) Remigiusz Dybka 2009 <remigiusz.dybka@gmail.com>
 *
 Zaz is free software: you can redistribute it and/or modify it
 under the terms of the GNU General Public License as published by the
 Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 Zaz is distributed in the hope that it will be useful, but
 WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 See the GNU General Public License for more details.

 You should have received a copy of the GNU General Public License along
 with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "directorylister.h"

vector<string> ListFiles(string dir, const string extension)
{
    vector<string> ret;
    DIR *d = opendir(dir.c_str());

    if (!d)
        return ret;

    struct dirent *file = readdir(d);
    while (file)
    {
#ifndef WIN32
        if (file->d_type == DT_REG)
#endif
        {

            string ext = file->d_name;
            size_t extpos = ext.find(extension);

            if (extpos != string::npos)
            {
                if ((extpos == ext.size() - extension.size()) || extension.empty())
                {
                    ret.push_back(file->d_name);
                }

            }
        }

        file = readdir(d);
    }

    closedir(d);
    return ret;
};
